<template>
  <div>
    Query: {{ $route.query }}
    <div class="links">
      <ul>
        <li v-for="link in links.local">
          <nuxt-link :to="`/dev-docs/?page=${encodeURIComponent(link)}`">{{link}}</nuxt-link>
        </li>
      </ul>
      <ul>
        <li v-for="link in links.dependencies">
          <nuxt-link :to="`/dev-docs/?page=${encodeURIComponent(link)}`">{{link}}</nuxt-link>
        </li>
      </ul>
    </div>

    <div v-if="html==null">Loading thing</div>
    <div v-else v-html="html" @click="htmlClick" />  
  </div>
</template>
<script>

import MarkdownIt from 'markdown-it';
import unet from 'unet';
const md = MarkdownIt();

function resolve(base='',path) {
  const basePieces = base.split('/');
  // drop last piece:
  basePieces.pop();
  
  const ret = path.split('/').reduce((current,piece) => {
    console.log("CURRENT: ",current);
    console.log("PIECE: ",piece);
    
    if(piece == '.') return current;
    if(piece == '..') return current.slice(0,current.length-1)
    else return current.concat([piece]);
  },basePieces);
  
  console.log("FINAL: ",ret);
  
  return ret.join('/');
}

export default {
  async asyncData(ctx) {
    return {
      links: (await unet({ url: (ctx.env.appPath || '')+'/dev-docs/api' })).result,
      markdown: await (await unet({ url: (ctx.env.appPath || '')+'/dev-docs/api/'+ctx.query.page})).response.text()
    };
  },
  methods: {
    htmlClick(event) {
      const target = event.target;
      const tag = target.tagName.toLowerCase();
      
      if(tag == 'a') {
        const href = target.attributes.href.nodeValue;
        
        if(href.match(/^\//)) {
          console.log("Passing on relative link: ",href);
        } else if(href.match(/^http/)) {
          console.log("Passing on absolute link: ",href);
        } else {
          event.preventDefault();
          event.stopPropagation();

          const newPath = resolve(this.$route.query.page,href);
          this.$router.push(`/dev-docs/?page=${encodeURIComponent(newPath)}`);
        }
      }
    },
  },
  computed: {
    html() {
      return md.render(this.markdown);
    },
  },
  watch: {
    '$route.query.page': {
      async handler() {
        const { response } = (await unet({ url: (this.$nuxt.$options.context.env.appPath || '')+'/dev-docs/api/'+this.$route.query.page}))
        this.markdown = await response.text();
      }
    }
  },
  
}
  
</script>
